#include <owl\pch.h>
#pragma hdrstop
#include <owl\controlb.h>
#include "3dctlbar.h"

DEFINE_RESPONSE_TABLE1(T3DControlBar, TControlBar)
	EV_WM_ERASEBKGND,
	EV_WM_SIZE,
END_RESPONSE_TABLE;


void T3DControlBar::EvSize(uint sizeType, TSize& size)
{
	TControlBar::EvSize(sizeType, size);
	Invalidate();
}


bool T3DControlBar::EvEraseBkgnd(HDC hDC)
{
	TDC dc(hDC);

	// SysColors that are bkgnds for text are never dithered & can use TextRect
	dc.TextRect(GetClientRect(), ::GetSysColor(COLOR_BTNFACE));

	// These sysColors might be dithered. PaBlt is an easy way to paint these
	TBrush highlight(::GetSysColor(COLOR_BTNHIGHLIGHT));
	dc.SelectObject(highlight);
	dc.PatBlt(0, 0, Attr.W, 1);
	dc.PatBlt(0, 1, 1, Attr.H - 2);

	TBrush shadow(::GetSysColor(COLOR_BTNSHADOW));
	dc.SelectObject(shadow);
	dc.PatBlt(1, Attr.H - 3, Attr.W - 1, 1);
	dc.PatBlt(Attr.W - 3, 1, 1, Attr.H - 4);

	return TRUE;
}

