#include <owl\applicat.h>
#include <owl\decframe.h>
#include <owl\controlb.h>
#include <owl\buttonga.h>
#include <owl\statusba.h>
#pragma hdrstop
#include "3dctlbar.h"
#include "stylstat.h"
#include "3dctlbar.rh"


class TWndw : public TDecoratedFrame
{
public:
	TWndw(TWindow *parent, const char far *title,	TWindow *client,
		bool trackMenuSelection);
protected:
	void CmOpen();
	void CmToggleHint();
	void CeToggleHint(TCommandEnabler&);
private:
	TControlBar *cntrlBar;
	TControlBar::THintMode hintMode;
DECLARE_RESPONSE_TABLE(TWndw);
};

DEFINE_RESPONSE_TABLE1(TWndw, TDecoratedFrame)
	EV_COMMAND(CM_OPEN, CmOpen),
	EV_COMMAND(CM_TOGGLEHINT, CmToggleHint),
	EV_COMMAND_ENABLE(CM_TOGGLEHINT, CeToggleHint),
END_RESPONSE_TABLE;


TWndw::TWndw(TWindow *parent, const char far *title, TWindow *clientWnd,
		bool trackMenuSelection)
	: TDecoratedFrame(parent, title, clientWnd, trackMenuSelection),
		hintMode(TControlBar::EnterHints)
{
	AssignMenu(MENU_1);
	Attr.X = 50;
	Attr.Y = 50;
	Attr.W = GetSystemMetrics(SM_CXSCREEN) / 1.5;
	Attr.H = GetSystemMetrics(SM_CYSCREEN) / 1.5;

	TButtonGadget *b;
	TSeparatorGadget *s;
	cntrlBar = new T3DControlBar(this);

	b = new TButtonGadget(BITMAP_OPEN, CM_OPEN);
	cntrlBar->Insert(*b);
	s = new TSeparatorGadget(2);
	cntrlBar->Insert(*s);
	b = new TButtonGadget(BITMAP_EXIT, CM_EXIT);
	cntrlBar->Insert(*b);

	cntrlBar->Attr.Id = CM_CONTROLBAR;
	cntrlBar->SetHintMode(hintMode);

	Insert(*cntrlBar);

	TStatusBar *statBar = new TStyleStatusBar(this, TGadget::Embossed,
		TStatusBar::CapsLock | TStatusBar::NumLock | TStatusBar::Overtype);
	Insert(*statBar, TDecoratedFrame::Bottom);
}

///////////////////////////////////////////////////////////
// TWndw::CmOpen()
///////////////////////////////////////////////////////////
void TWndw::CmOpen()
{
	MessageBox("CM_OPEN received", "Message", MB_OK);
}


void TWndw::CeToggleHint(TCommandEnabler& ce)
{
	ce.SetCheck(hintMode == TGadgetWindow::EnterHints);
}


void TWndw::CmToggleHint()
{
	hintMode = hintMode == TGadgetWindow::PressHints ?
		TGadgetWindow::EnterHints :
		TGadgetWindow::PressHints;

	cntrlBar->SetHintMode(hintMode);
	cntrlBar->SetHintCommand(-1);  // make sure we don't leave hint text dangling
}

///////////////////////////////////////////////////////////////////////////
class TApp : public TApplication
{
public:
	TApp(): TApplication() {}
	void InitMainWindow();
};


void TApp::InitMainWindow()
{
	TWindow *client = new TWindow(0,0,0);
	TDecoratedFrame *wndw = new TWndw(0, "3D Control Bar", client, TRUE);

	SetMainWindow(wndw);
	EnableCtl3d();
}


int OwlMain(int, char*[])
{
	return TApp().Run();
}

